
import
  preserves, std/tables

type
  WebsocketArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `url`*: string

  WebsocketArguments* {.preservesRecord: "websocket".} = object
    `field0`*: WebsocketArgumentsField0

  JsonTranslatorArgumentsField0* {.preservesDictionary.} = object
    `argv`*: seq[string]
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  JsonTranslatorArguments* {.preservesRecord: "json-stdio-translator".} = object
    `field0`*: JsonTranslatorArgumentsField0

  SocketAddressKind* {.pure.} = enum
    `TcpAddress`, `UnixAddress`
  `SocketAddress`* {.preservesOr.} = object
    case orKind*: SocketAddressKind
    of SocketAddressKind.`TcpAddress`:
        `tcpaddress`*: TcpAddress

    of SocketAddressKind.`UnixAddress`:
        `unixaddress`*: UnixAddress

  
  Base64DecoderArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  Base64DecoderArguments* {.preservesRecord: "base64-decoder".} = object
    `field0`*: Base64DecoderArgumentsField0

  JsonTranslatorConnected* {.preservesRecord: "connected".} = object
    `address`*: SocketAddress

  JsonSocketTranslatorArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `socket`*: SocketAddress

  JsonSocketTranslatorArguments* {.preservesRecord: "json-socket-translator".} = object
    `field0`*: JsonSocketTranslatorArgumentsField0

  XsltArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  XsltArguments* {.preservesRecord: "xslt".} = object
    `field0`*: XsltArgumentsField0

  HttpDriverArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  HttpDriverArguments* {.preservesRecord: "http-driver".} = object
    `field0`*: HttpDriverArgumentsField0

  WebhooksArgumentsField0* {.preservesDictionary.} = object
    `endpoints`*: Table[seq[string], EmbeddedRef]
    `listen`*: Tcp

  WebhooksArguments* {.preservesRecord: "webhooks".} = object
    `field0`*: WebhooksArgumentsField0

  FileSystemUsageArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  FileSystemUsageArguments* {.preservesRecord: "file-system-usage".} = object
    `field0`*: FileSystemUsageArgumentsField0

  SqliteArgumentsField0* {.preservesDictionary.} = object
    `database`*: string
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  SqliteArguments* {.preservesRecord: "sqlite".} = object
    `field0`*: SqliteArgumentsField0

  TcpAddress* {.preservesRecord: "tcp".} = object
    `host`*: string
    `port`*: BiggestInt

  CacheArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `lifetime`*: float

  CacheArguments* {.preservesRecord: "cache".} = object
    `field0`*: CacheArgumentsField0

  XmlTranslatorArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  XmlTranslatorArguments* {.preservesRecord: "xml-translator".} = object
    `field0`*: XmlTranslatorArgumentsField0

  PostgreConnectionParameter* {.preservesTuple.} = object
    `key`*: string
    `val`*: string

  PostgreArgumentsField0* {.preservesDictionary.} = object
    `connection`*: seq[PostgreConnectionParameter]
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  PostgreArguments* {.preservesRecord: "postgre".} = object
    `field0`*: PostgreArgumentsField0

  PulseArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  PulseArguments* {.preservesRecord: "pulse".} = object
    `field0`*: PulseArgumentsField0

  UnixAddress* {.preservesRecord: "unix".} = object
    `path`*: string

  Tcp* {.preservesRecord: "tcp".} = object
    `host`*: string
    `port`*: BiggestInt

proc `$`*(x: WebsocketArguments | JsonTranslatorArguments | SocketAddress |
    Base64DecoderArguments |
    JsonTranslatorConnected |
    JsonSocketTranslatorArguments |
    XsltArguments |
    HttpDriverArguments |
    WebhooksArguments |
    FileSystemUsageArguments |
    SqliteArguments |
    TcpAddress |
    CacheArguments |
    XmlTranslatorArguments |
    PostgreConnectionParameter |
    PostgreArguments |
    PulseArguments |
    UnixAddress |
    Tcp): string =
  `$`(toPreserves(x))

proc encode*(x: WebsocketArguments | JsonTranslatorArguments | SocketAddress |
    Base64DecoderArguments |
    JsonTranslatorConnected |
    JsonSocketTranslatorArguments |
    XsltArguments |
    HttpDriverArguments |
    WebhooksArguments |
    FileSystemUsageArguments |
    SqliteArguments |
    TcpAddress |
    CacheArguments |
    XmlTranslatorArguments |
    PostgreConnectionParameter |
    PostgreArguments |
    PulseArguments |
    UnixAddress |
    Tcp): seq[byte] =
  encode(toPreserves(x))
